/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include  "led.h"
#include "BLEProcess.h"
#include "main.h"



int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */

    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    InitializeSystem();
    for(;;)
    {
        /* Place your application code here. */
        CyBle_ProcessEvents();
    }
}

void GeneralEventHandler(uint32 event, void * eventParam)
{
/* Structure to store data written by Client */
CYBLE_GATTS_WRITE_REQ_PARAM_T *wrReqParam;
/* 'RGBledData[]' is an array to store 4 bytes of RGB LED data*/
    uint8 RGBledData[RGB_CHAR_DATA_LEN];
switch(event)
{
    case CYBLE_EVT_STACK_ON:
    /* This event is generated when BLE stack is ON */
    /* BLE stack is on. Start BLE advertisement */
        CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);

    break;
    case CYBLE_EVT_GAP_DEVICE_DISCONNECTED:
            /* This event is generated at GAP disconnection. */
                /* This event is generated at GAP disconnection. */
     /* This event is generated at GAP disconnection. */
            /* Reset the color values*/
            RGBledData[RED_INDEX] = FALSE;
            RGBledData[GREEN_INDEX] = FALSE;
            RGBledData[BLUE_INDEX] = FALSE;
            RGBledData[INTENSITY_INDEX] = FALSE;
            /* Switch off LEDs */
            UpdateRGBLED(RGBledData, sizeof(RGBledData));
            /* Register the new color in GATT DB*/
            UpdateRGBcharacteristic(RGBledData,
            sizeof(RGBledData),
            CYBLE_RGB_LED_RGB_LED_CONTROL_CHAR_HANDLE);
            /* Restart advertisement */
            CyBle_GappStartAdvertisement(CYBLE_ADVERTISING_FAST);
    break;
            case CYBLE_EVT_GATTS_WRITE_REQ:
            /* This event is generated when the connected Central */
            /* device sends a Write request. */
            /* The parameter ‘eventParam’ contains the data written */
            /* Extract the Write data sent by Client */
        wrReqParam = (CYBLE_GATTS_WRITE_REQ_PARAM_T *) eventParam;
        /* If the attribute handle of the characteristic written to
        * is equal to that of RGB_LED characteristic, then extract
        * the RGB LED data */
        if(CYBLE_RGB_LED_RGB_LED_CONTROL_CHAR_HANDLE ==
        wrReqParam->handleValPair.attrHandle)
        {
            /* Store RGB LED data in local array */
            RGBledData[RED_INDEX] =
            wrReqParam->handleValPair.value.val[RED_INDEX];
            RGBledData[GREEN_INDEX] =
            wrReqParam->handleValPair.value.val[GREEN_INDEX];
            RGBledData[BLUE_INDEX] =
            wrReqParam->handleValPair.value.val[BLUE_INDEX];
            RGBledData[INTENSITY_INDEX] =
            wrReqParam->handleValPair.value.val[INTENSITY_INDEX];
            /* Update the PrISM component density value to represent color */
            UpdateRGBLED(RGBledData, sizeof(RGBledData));
            /* Update the GATT DB for RGB LED read characteristics*/
            UpdateRGBcharacteristic(RGBledData,
            sizeof(RGBledData),
            CYBLE_RGB_LED_RGB_LED_CONTROL_CHAR_HANDLE);
        }
        /* Send the response to the write request received. */
        CyBle_GattsWriteRsp(cyBle_connHandle);
    break;
    default:
    break;
}
}


void InitializeSystem(void)
{
/* Enable Global Interrupt Mask */
    CyGlobalIntEnable;
/* Start BLE stack and register the event callback function. */
    CyBle_Start(GeneralEventHandler);
/* Start PrISM modules for LED control */
    PrISM_1_Start();
    PrISM_2_Start();
/* Switch off the RGB LEDs through PrISM modules */
    PrISM_1_WritePulse0(RGB_LED_OFF);
    PrISM_1_WritePulse1(RGB_LED_OFF);
    PrISM_2_WritePulse0(RGB_LED_OFF);
/* Set Drive modes of the output pins to Strong */
    RED_SetDriveMode(RED_DM_STRONG);
    GREEN_SetDriveMode(GREEN_DM_STRONG);
    BLUE_SetDriveMode(BLUE_DM_STRONG);
}

/* [] END OF FILE */
